################################
##OPRATIONS DE BASE

##gnrer une page HTML pour naviguer dans les fichiers d'aide
help.start( )

##faire un recherche sur un mot-cl ou thme pour trouver des
##fonctions qui traite du sujet
help.search(apropos = "generalized linear models")

##rechercher de l'aide sur une fonction particulire
?mean
?glm

##changer le format de l'aide - par dfaut, html
options(help_type = "text")


##rechercher de l'aide sur le forum de R
RSiteSearch("glm")



##chercher les archives de la liste de R sur le web
RSiteSearch("creating eps file")

##crer un objet qui contient des donnes
y <- 15.3
y
Y #sensible aux majuscules et minuscules





##entrer des donnes et les fixer  un objet
y <- c(1, 12, 31, 14, 50, 22, 13, 14, 25, 26)

         



##slectionner la sixime observation de la variable y
y[6]
y




##crer une variable avec la valeur rpte 20 fois
new_y <- rep(x = 5, times = 20)
new_z <- rep(x = c("new", "old"), times = 3)






##crer une variable avec la squence continue de 1  10 avec un pas de 1
y2 <- seq(from = 1, to = 10, by = 1)
y3 <- seq(from = 10, to = 1, by = -2)



class(y3)
is.numeric(y3)
class(new_z)
is.numeric(new_z)
is.character(new_z)

length(y)




##calculs arithmtiques
30+10
2*5
15/3
y+y2
2-y2


sum(y)
prod(y)
2^3
round(123.3453, digits = 2)
round(123.3453, digits = 0)

range(y)




##calculer 1ire drive de dx2/dx
D(expression(x^2),"x")
D(expression(x+(x^2)+(2*z^3)), "z")

##calculer intgrale
integrate(dnorm, -1.96, 1.96) #aire sous la courbe d'une distribution normale centre rduite entre -1.96 et 1.96.





##crer une matrice
mat <- matrix(data = c(1:9), nrow = 3, ncol = 3)
mat
mat<-matrix(data = c(1:9), nrow = 3, ncol = 3, byrow = TRUE)
mat
class(mat)
is.numeric(mat)
is.vector(mat)
length(mat)
dim(mat)

##obtenir diagonale de la matrice
diag(mat)



##slectionner l'lment de la premire range et deuxime colonne
mat[1,2]
mat[3,1]
mat[,1]
mat[2,]
mat[1:2,1]
mat[c(1,3),3]

##calculer transpose de matrice
mat_transpose <- t(mat)


##calculer inverse de matrice
mat1 <- matrix(data = y[1:9], nrow = 3, ncol = 3)
mat1_inv <- solve(mat1)

##dfinition d'inverse de matrice
def_inv <- mat1%*%mat1_inv
round(def_inv, digits = 4)

##multiplier matrice par un vecteur
vecteur <- c(2, 4, 5)
mat%*%vecteur

colSums(mat)
colMeans(mat)
rowSums(mat)
rowMeans(mat)



##data frames
Temps <- c(1.2, 3.4, 2.1, 5.5)
Masse <- c(2.5, 4.2, 5.6, 3.4)
Sexe <- c("mle", "femelle", "mle", "femelle")
jeu <- data.frame(Temps, Masse, Sexe)
class(jeu)
length(jeu)
dim(jeu)

##structure du fichier
str(jeu)
##rsum des variables
summary(jeu)
##premires observations
head(jeu)
##dernires observations
tail(jeu)



data_set <- data.frame(Vitesse = c(25, 40, 70, 100), Type = c("auto", "camion", "auto", "camion"))
Vitesse
data_set$Type
data_set[,2]
attach(data_set)

data_set$log_Vitesse <- log(data_set$Vitesse)
log_vitesse
data_set
detach(data_set)
data_set$log_Vitesse
attach(data_set$log_Vitesse)
log_Vitesse

                        
##importer jeu de donnes
worms <- read.table(file = "c:\\Documents and Settings\\mazerolm\\Maz folders\\Biostat cours Hiver 2007\\Biostat cours Automne 2007\\Cours 1 (Paramtres et statistiques)\\Worms.txt", header = TRUE)
##importation sans arguments header=TRUE bouleverse les colonnes
worms_b <- read.table(file = "c:\\Documents and Settings\\mazerolm\\Maz folders\\Biostat cours Hiver 2007\\Biostat cours Automne 2007\\Cours 1 (Paramtres et statistiques)\\Worms.txt")
##autre stratgie: importation avec file.choose() permet d'importer sans avoir  indiquer tout le chemin
worms_c <- read.table(file = file.choose(), header = TRUE)
##autre stratgie: on peut aussi assigner le rpertoire de travail ds le dbut de la session et R ira chercher les lments directement dedans
setwd(dir = "c:\\Documents and Settings\\mazerolm\\Maz folders\\Biostat cours Hiver 2007\\Biostat cours Automne 2007\\Cours 1 (Paramtres et statistiques)")
worms_d <- read.table(file = "Worms.txt", header = TRUE)

attach(worms)
names(worms)
summary(worms)
plot(worms)

##utiliser indices
worms[1,]
worms[1:15,]
worms[,3]
worms[,3:5]
worms[1,3:5]


##tests logiques
worms$Slope == 0
worms$Slope > 0
worms$Slope != 0
worms$Vegetation == "Grassland"

which(worms$Slope != 0)
which(worms$Vegetation == "Grassland")

##crer une variable binaire  partir d'un test logique
worms$Grassland <- ifelse(worms$Vegetation == "Grassland", 1, 0)
##crer une variable catgorique  plusieurs niveaux  partir de plusieurs tests logiques
worms$Slope_cat <- ifelse(worms$Slope >= 0 & worms$Slope < 3, "Low", ifelse(worms$Slope >= 3 & worms$Slope < 6, "Med",
ifelse(worms$Slope >= 6 & worms$Slope < 9, "High", "Very High")))


##utiliser tests logiques
worms[worms$Vegetation == "Meadow",]
worms[worms$Area > 3 & worms$Slope < 3,]
subset(x = worms, subset = worms$Area > 3 & worms$Slope < 3 )

##faire un tri
order(worms$Slope)
worms[order(worms[,1]), 1:6] #trier les colonnes 1-6 par les valeurs de la colonne 1 (le nom du site)
rev(order(worms$Slope))
worms[rev(order(worms[,1])), 1:6]
worms[rev(order(worms[,c(1,2)])), ]

##cross-classification
table(worms$Vegetation)
table(worms$Vegetation, worms$Damp)



##effet de traitement sur la rduction de douleur chez personnes ges 6 mois aprs traitement, et dure des symptmes (mois) avant traitement
neural <- read.table("C:/Documents and Settings/mazerolm/Maz folders/Biostat cours Hiver 2007/Neural.txt", header = TRUE)
neural$Reduce <- as.factor(neural$Reduce)
neural$Treatment <- as.factor(neural$Treatment)

##fonction table pour rsumer donner de frquence selon variable catgorique
tab <- table(neural$Reduce, neural$Treatment, deparse.level = 2)
tab <- as.data.frame(tab)

##accder aux jeux de donnes dja inclus dans R data( )
admissions <- as.data.frame(UCBAdmissions)
xtabs(Freq ~ Gender + Admit, data = admissions)


##modifier le format du jeu de donnes
##jeu de donnes en format long - une colonne pour toutes les concentrations
Indometh
##rorganiser le jeu de donnes pour avoir
##une colonne par concentration - 1 sujet = 1 ligne
wide <- reshape(data = Indometh, idvar = "Subject",
timevar = "time", direction = "wide")
##remettre en format long avec 1 ligne par concentration
reshape(wide, direction = "long")

##fonctions similaires pour rarranger jeu de donnes
?stack
?unstack


##sauvegarder fichier en valeurs spares par tabulations
write.table(x = neural, file = "neural.txt", row.names = FALSE, col.names = TRUE, sep = "\t")
##sauvegarder fichier en valeurs spares par 1 espace
write.table(x = neural, file = "neural.txt", row.names = FALSE, col.names = TRUE, sep = " ")
##sauvegarder fichier en valeurs spares par 5 espaces
write.table(x = neural, file = "neural.txt", row.names = FALSE, col.names = TRUE, sep = "     ")
##sauvegarder fichier en valeurs spares par virgule
write.table(x = neural, file = "neural.txt", row.names = FALSE, col.names = TRUE, sep = ",")

################################################################
##GRAPHIQUES
hist(worms$Worm.density)     #gnrer un histogramme
barplot(worms$Worm.density, xlab = "Numro de l'observation", ylab = "Densit de vers de terre",
        names.arg = c(1:20)) #gnrer un diagramme  barre avec quelques modifications des tiquettes des axes
boxplot(worms$Worm.density ~ worms$Vegetation)  #gnrer un diagramme de bote et moustaches
barplot(worms$Worm.density, xlab = "Numro de l'observation", ylab = "Densit de vers de terre",
        names.arg = c(1:20)) #gnrer un diagramme  barre avec quelques modifications des tiquettes des axes
plot(worms$Worm.density ~ worms$Area)     #gnrer un diagramme  point "scatter plot"
qqnorm(worms$Worm.density)    #crer un graphique quantile-quantile afin de dterminer si la variable est distribue normalement
qqline(worms$Worm.density)    #ajouter une ligne indiquant le patron qui devrait tre observ si la variable tait distribue normalement

##ajouter une droite et une quation prdictive
plot(worms$Worm.density ~ worms$Area, ylab = "Density", xlab = "Area", cex.lab = 1.3)     #gnrer un diagramme  point "scatter plot"
mod1 <- lm(Worm.density ~ Area, data = worms)
abline(reg = mod1)
text(x = 1.5, y = 4.5, labels = expression(paste(italic(hat(y)), " = ", beta[0], " + ", beta[1], "*Area")),
     cex = 1.5, col = "darkblue")
text(x = 1.5, y = 3, labels = expression(paste(italic(R)^2, " = 2.8%")), cex = 1.5, col = "red")


plot(worms$Worm.density ~ worms$Area)     #gnrer un diagramme  point "scatter plot"
abline(h = 3, v = 5, col = c("red", "blue"))
points(x = 1, y = 4, pch = "+", col = 3, cex = 1.5)
text(x = 2, y = 6, labels = "une rgion du graphique", col = "magenta")

##modifications aux graphiques
plot(x = 1, y = 1, ylab = "Axe des y", xlab = "Axe des x", cex.lab = 1.5)
mtext(side = 3, text = expression(chi^2), line = 1, cex = 1.3)
plot(1, 1, main = expression(alpha + beta +psi[i] +theta^2 +epsilon[i]), ylab = "Axe des y", cex.lab = 1.5,
     xlab = "Axe des x", cex.main = 2) #ajouter indices, exposants, lettres grecques
text(0.8, 1.2, labels = expression(italic(italiques)), cex = 1.3)    #ajouter du texte  la position (x,y) en italiques et augmenter la taille des caractres (1.3 fois plus gros)
text(1, 1.2, labels = expression(bold(gras)), cex = 2)               #ajouter du texte  la position (x,y) en gras et doubler la taille des caractres
points(1, 1.3, pch = "o", col = 2, cex = 1.5)                          #ajouter un point  la position (x,y) avec couleur=2
points(x = 1.2,y = 1.3, pch = "P", col = "blue", cex = 3)                     #ajouter un point  la position (x,y) sur le graphique de couleur bleue
?plot     #pour voir les options possibles de plot
?par      #pour voir la liste complte des options pouvant tre modifie concernant les graphiques




################################################
##mettre plusieurs lments sur graphique avec barres d'erreur et lgende
###################################
##crer jeu de donnes
##groupe supplment "agrimore"
agri <- data.frame(Means = c(26.35, 23.30, 19.64), SD = c(1.84, 1.23, 1.42),
Diet = c("barley", "oats", "wheat"))

##groupe supplment "control"
cont <- data.frame(Means = c(23.30, 20.49, 17.41), SD = c(1.41, 1.01, 0.92),
Diet = c("barley", "oats", "wheat"))

##crer graphique vide sans axe des x's avec type = "n" et xaxt = "n"
plot(y = 0, x = 0, type = "n", ylab = "Moyenne de gain de masse (kg)",
xlab = "Dite", xaxt = "n", xlim = c(0, 4), ylim = c(0, 30))
title(main = expression(paste("Moyennes  ", italic(SD))))
## si on prfre, on peut ajouter x barre en italiques avec mtext( )
##mtext(side = 3, text = expression(paste(bar(italic(x)), "  ", italic(SD))),
##line = 1)


##ajouter axe des x's avec tiquettes
axis(side = 1, at = c(1, 2, 3), labels = c("Orge", "Avoine", "Bl"))

##ajouter points pour groupe "agrimore"
points(y = agri$Means, x = c(1, 2, 3), pch = 1)

##ajouter points pour groupe "control"
points(y = cont$Means, x = c(1, 2, 3), col = "blue", pch = 2)

##ajouter barres d'erreur (SD) pour groupe "agrimore"
low.bars <- agri$Means - agri$SD
up.bars <- agri$Means + agri$SD
arrows(x0 = c(1, 2, 3), y0 = low.bars, x1 = c(1, 2, 3), y1 = up.bars, length = 0.05, angle=90, code=3)

##ajouter barres d'erreur (SD) pour groupe "contrle"
low.bars2 <- cont$Means - cont$SD
up.bars2 <- cont$Means + cont$SD
arrows(x0 = c(1, 2, 3), y0 = low.bars2, x1 = c(1, 2, 3), y1 = up.bars2, length = 0.05, angle=90, code=3)

##ajouter lgende
legend(x = "left", legend = c("agrimore", "contrle"), pch = c(1, 2),
col = c("black", "blue"), title = "Supplment")
#####################


##ajouter plusieurs graphiques sur mme page
par(mfrow = c(2, 2))
hist(worms$Worm.density)
boxplot(worms$Worm.density)
barplot(worms$Worm.density)
plot(worms$Worm.density ~ worms$Area)

par(mfcol = c(2, 2))
hist(worms$Worm.density)
boxplot(worms$Worm.density)
barplot(worms$Worm.density)
plot(worms$Worm.density ~ worms$Area)


par(mfrow = c(2, 2))
plot(1, 1, ylim = c(0, 5), xlim = c(0, 5), type = "n")
text(1, 1, "A", cex = 3)
plot(1, 1, ylim = c(0, 5), xlim = c(0, 5), type = "n")
text(1, 1, "B", cex = 3)
plot(1, 1, ylim = c(0, 5), xlim = c(0, 5), type = "n")
text(1, 1, "C", cex = 3)
plot(1, 1, ylim = c(0, 5), xlim = c(0, 5), type = "n")
text(1, 1, "D", cex = 3)

par(mfcol = c(2, 2))
plot(1, 1, ylim = c(0, 5), xlim = c(0, 5), type = "n")
text(1, 1, "A", cex = 3)
plot(1, 1, ylim = c(0, 5), xlim = c(0, 5), type = "n")
text(1, 1, "B", cex = 3)
plot(1, 1, ylim = c(0, 5), xlim = c(0, 5), type = "n")
text(1, 1, "C", cex = 3)
plot(1, 1, ylim = c(0, 5), xlim = c(0, 5), type = "n")
text(1, 1, "D", cex = 3)


######################################
##ajouter une droite et une quation prdictive
mod1 <- lm(Worm.density ~ Area, data = worms)
plot(worms$Worm.density ~ worms$Area, ylab = "Density", xlab = "Area", cex.lab = 1.3)     #gnrer un diagramme  point "scatter plot"

##calculer valeurs prdites avec SE
pred.vals <- predict(mod1, se.fit = TRUE)

##ajouter valeurs prdites et SE au jeu de donnes
worms$fit <- pred.vals$fit
worms$se.fit <- pred.vals$se.fit

##trier le jeu de donnes en ordre de valeurs prdites
##il faut trier les valeurs prdites afin que les lignes s'affichent
##correctement; sinon, on obtient des patrons chaotiques de zigzags
worms.ord <- worms[order(worms$fit), ]

##ajouter la droite prdictive
lines(y = worms.ord$fit, x = worms.ord$Area)

##calculer intervalle de confiance  95% autour des prdictions
upp.lim <- worms.ord$fit + 1.96*worms.ord$se.fit
low.lim <- worms.ord$fit - 1.96*worms.ord$se.fit

##ajouter limites autour de droite de prdiction
lines(y = upp.lim, x = worms.ord$Area, lty = "dashed")
lines(y = low.lim, x = worms.ord$Area, lty = "dashed")
######################################



##crer fichier graphique pdf
pdf(file = "C:\\Fig1.pdf")
plot(x = c(1, 2), y = c(6, 5))

##crer fichier graphique postscript
postscript(file = "C:\\Fig1.ps")
plot(x = c(1, 2), y = c(6, 5))

##restaurer la fentre graphique
windows()
plot(x = c(1, 2), y = c(6, 5))

##crer fichier graphique eps
dev.copy2eps(file = "C:\\Fig1.eps")

#


##############################################################
##STATISTIQUES DE BASE
##crer une variable alatoire avec 30 observations et provenant d'une distribution normale avec moyenne=12 et sd=3
var1 <- rnorm(n = 30, mean = 12, sd = 3)

##probabilit que x=5 provienne d'une distribution normale avec moyenne=2 et sd=3
dnorm(x = 5, mean = 2, sd = 3)

##probabilit que x > 1.96
1-pnorm(q = 1.96, mean = 0, sd = 1)

##fonction de quantile
qnorm(p = 0.975, mean = 0, sd = 1)


##calculer la moyenne
moy_var1 <- mean(var1)

##calculer cart-type
sd_var1 <- sd(var1)

##mdiane
median(var1)

##quantile
quantile(var1)

##rang
rank(var1)

##calculer erreur-type
SE_var1 <- sd(var1)/sqrt(length(var1))


################################
##FUNCTIONS
##fonction pour calculer erreur-type
SE_fonction <- function(x) {
n_x <- length(x)
sd_x <- sd(x)
sd_x/sqrt(n_x)
}

##square root of value
racine_car <- function(valeur) {
valeur^(1/2)
}
racine_car(4)
racine_car(329)
sqrt(4)
sqrt(329)

##root x of variable
racine_x <- function(valeur, niveau) {
valeur^(1/niveau)
}
racine_x(valeur = 8, niveau = 3)

##root x of variable with default
racine_x <- function(valeur, niveau = 2) {
valeur^(1/niveau)
}
racine_x(16)
racine_x(16, 2)


##extract sum, min, max
sum_max_min <- function(variable){
the_sum <- sum(variable)
the_min <- min(variable)
the_max <- max(variable)
list("Sum_of_observations" = the_sum,
"Minimum_value" = the_min, "Maximum_value" = the_max)
}
x <- rnorm(30)
sum_max_min(x)

result <- sum_max_min(x)
result$Sum_of_observations
result$Minimum_value
result$Maximum_value


##version un peu plus labore ajoutant le nom de variable
##et premire observation
sum_max_min_x <- function(variable){
the_sum <- sum(variable)
the_min <- min(variable)
the_max <- max(variable)
list("Variable" = deparse(substitute(variable)),
"First.obs" = head(x), "Sum_of_observations" = the_sum,
"Minimum_value" = the_min, "Maximum_value" = the_max)
}
essai2 <- rnorm(30)
sum_max_min_x(essai2)

result <- sum_max_min_x(x)




###################
##LOOPS
##crer un objet pour stocker output
output <- rep(x = NA, times = 100)
for (i in 1:100) {
cat("iter" = i, "\n")  #afficher le numro de l'itration
simdata <- rnorm(n = 30, mean = 10, sd = 1)
output[i] <- mean(simdata)
}
mean(output)



###################
##Exemple o on veut gnrer des chantillons de 10 observations et calculer la moyenne pour chacun en illustrant l'utilisation de boucles - un exemple de bootstrap

##spcifier le nombre d'chantillons
nsims <- 100
##crer un objet o placer les rsultats
mean_data < -rep(NA, nsims)
##afficher l'objet qui contiendra les moyennes
mean_data

##dbuter la boucle
for (i in 1:nsims) {            #for indique qu'on effectue tout ce qui se trouve entre { } pour l'itration i;  l'itration 1 on gnre un chantillon, on calcule sa moyenne et on stocke l'information dans l'objet mean_data, on recommence avec l'itration 2, etc...
mean_data[i] <- mean(rnorm(n = 10, mean = 5, sd = 3))
}
##afficher les rsultats
mean_data

hist(mean_data) #histogramme de la distribution des moyennes des chantillons

mean(mean_data) #la grande moyenne des moyennes des chantillons
sd(mean_data)   #cart-type des moyennes == ERREUR-TYPE



################
##example de bootstrap
dbh <- c(3, 22, 8, 50, 9, 22, 26, 46, 28, 16, 33, 45, 18, 34)

##fix number of bootstrap samples
nsims <- 1000

##set up object to hold results
boot_out <- rep(NA, nsims)

##initiate loop
for (i in 1:nsims) {
bootsample <- sample(x = dbh, size = length(dbh), replace = TRUE)
boot_out[i] <- mean(bootsample)
}

##distribution of means
hist(boot_out, main = expression(paste("Distribution des moyennes ", bar(x))))

##SE of mean is sd of all means
sd(boot_out)









##fonctions qui agissent un peu comme des boucles (mais plus efficacement)
tapply(X = worms$Worm.density, INDEX = worms$Vegetation, FUN = mean)
sapply(X = split(x = worms$Worm.density, f = worms$Vegetation), FUN = mean)

##lapply example
out <- list("m1" = rnorm(10), "m2" = rnorm(10), "m3" = rnorm(10))
lapply(X = out, FUN = length)





#################################################################
##ANALYSES STATISTIQUES
##chi-square
##is proportion same across different size classes?
Freq <- c(124, 176, 180)
chisq.test(Freq, p = c(1/3, 1/3, 1/3))


##test-t pour deux groupes
data(sleep) #patients given 1 of 2 drugs and the increase in sleep relative to control

##t-test
t.test(extra ~ group, mu = 0, data = sleep)
result <- t.test(extra ~ group, mu = 0, data = sleep)
names(result)
result$statistic


##Corrlation de Pearson
x1 <- rnorm(n = 30, mean = 2, sd = 1)
x2 <- rpois(n = 30, lambda = 5)
cor(x1, x2)
cor.test(x1, x2)

##RGRESSION LINAIRE
chocs <- read.table("L:/home/mazerolm/Documents/Stats Consulting/R Intro Workshop/chocs_red.dat",
                    header = TRUE)
mod_reglin <- lm(Price ~ Size, data = chocs)
summary(mod_reglin)

##extraction de l'information de l'objet de rsultats
##names()
names(mod_reglin)
mod_reglin$coefficients
mod_reglin$residuals

##log-likelihood du modle
logLik(mod_reglin)

##mesures d'influence (effet de levier, influence)
influence.measures(mod_reglin)

##rsidus de Student
rstudent(mod_reglin)

##graphique de l'objet de rgression
layout(mat = matrix(1:4, nrow = 2, ncol = 2))
plot(mod_reglin)


##graphique de rsidus de Student vs valeurs prdites
plot(rstudent(mod_reglin) ~ fitted(mod_reglin))
##identifier des points sur le graphique
identify(rstudent(mod_reglin) ~ fitted(mod_reglin))

identify(rstudent(mod_reglin) ~ fitted(mod_reglin),
labels = rownames(chocs))




##ANOVA classique, compltement alatoire
mod_anova <- aov(Growth ~ Dose + Humidity + Dose:Humidity, data = semis)
summary(mod_anova)




##RGRESSION LINAIRE
mod_reglin <- lm(Growth ~ Dose + Humidity + Dose:Humidity, data = semis)
summary(mod_reglin)

##extraction de l'information de l'objet de rsultats
##names()
names(mod_reglin)
mod_reglin$coefficients

##log-likelihood du modle
logLik(mod_reglin)

##graphique de l'objet de rgression
plot(mod_reglin)

##graphique de rsidus de Student vs valeurs prdites
plot(rstudent(mod_reglin) ~ fitted(mod_reglin))
##identifier des points sur le graphique
identify(rstudent(mod_reglin) ~ fitted(mod_reglin))

##mesures d'influence (effet de levier, influence)
influence.measures(mod_reglin)







##GLM's: rgression de Poisson
##nombre d'espces dans quadrats en fonction de biomasse et pH
species <- read.table("L:/home/mazerolm/Documents/Stats consulting/R Intro Workshop/2-day workshop/Bundle.fr/Species.txt",
                      header = TRUE)
species

##graphiques
plot(Species ~ Biomass, data = species, ylab = "Nombre d'espces", xlab = "Biomasse",
     main = "Nombre d'espces vs Biomasse")
text(8, 37, labels = "Est-ce une valeur extrme?")
plot(Species ~ pH, data = species, ylab = "Nombre d'espces", xlab = "pH",
     main = "Nombre d'espces vs pH")



##rgression de Poisson
mod_GLM1 <- glm(Species ~ Biomass + pH, family = poisson, data = species)
summary(mod_GLM1)


##################
##utiliser high comme niveau de rfrence comme SAS
species$pH <- relevel(species$pH, ref = "high")
mod_GLM1 <- glm(Species ~ Biomass + pH, family = poisson, data = species)
summary(mod_GLM1)
###################

##diagnostiques de l'ajustement
layout(mat = matrix(1:4, nrow = 2, ncol = 2))
plot(mod_GLM1)
##patron bizarre (courbe) avec les rsidus,
##alors qu'il ne doit y avoir aucun patron
##si l'ajustement est bon

##essayons un modle avec interaction Biomasse x pH
##analogue  l'ANCOVA
mod_GLM2 <- glm(Species ~ Biomass + pH + Biomass:pH, family = poisson, data = species)
summary(mod_GLM2)
##diagnostiques de l'ajustement
layout(mat = matrix(1:4, nrow = 2, ncol = 2))
plot(mod_GLM2)

##vrification de supposition de dispersion = 1
##khi-carr
chisq <- sum(residuals(mod_GLM2, type = "pearson")^2)
residual.df <- mod_GLM2$df.residual
c.hat <- chisq/residual.df

##effet de biomasse pour pH high:
coef(mod_GLM2)[2]
##effet de biomasse pour pH low:
coef(mod_GLM2)[2] + coef(mod_GLM2)[5]
##effet de biomasse pour pH mid:
coef(mod_GLM2)[2] + coef(mod_GLM2)[6]






##rgression logistique
##effet de traitement sur la rduction de douleur chez personnes ges 6 mois aprs traitement, et dure des symptmes (mois) avant traitement
neural <- read.table("C:/Documents and Settings/mazerolm/Maz folders/Biostat cours Hiver 2007/Neural.txt",
                     header = TRUE)

##fonction table pour rsumer donner de frquence selon variable catgorique
table(neural$Reduce, neural$Treatment, deparse.level = 2)

mod1 <- glm(Reduce ~ Age + Gender, family = binomial(link = logit), data = neural)
summary(mod1)




################################
##PACKAGES

##vrifier quels packages sont dja installs (et o ils sont stocks)
library()

##activer un package, ici le package 'MASS'
library(MASS)

##dsactiver un package, ici le package 'MASS'
detach(package:MASS)

##installer un package  partir du site de CRAN
install.packages()

##mettre  jour les packages dja installs (bonne ide de le faire rgulirement)
update.packages()